<template>
  <div>
    <h1>Вибрані уроки:</h1>
    <ul>
      <li v-for="subjectId in subjectIdsArray" :key="subjectId">
        {{ getSubjectName(subjectId) }}
        <select v-model="selectedTeacher[subjectId]">
          <option v-for="teacher in teachersList" :key="teacher.id" :value="teacher.id">
            {{ teacher.name }}
          </option>
        </select>
      </li>
    </ul>
    <button @click="startLearning">Розпочати навчання</button>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  name: "subjectsSelect",

  props: {
    subjectIds: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      selectedTeacher: {},
    };
  },
  computed: {
    ...mapGetters(['teachersGetter', 'subjectByIdGetter']),
     subjectIdsArray() {
      return this.subjectIds.split('/');
    },
    teachersList() {
      return this.teachersGetter;
    },
  },
  methods: {
    getSubjectName(subjectId) {
      const subject = this.subjectByIdGetter(subjectId);
      return subject ? subject.name : `Урок з ID ${subjectId}`;
    },
    startLearning() {
      if (Object.keys(this.selectedTeacher).length > 0) {
        const subjectTeacherPairs = this.subjectIdsArray.map(
          (subjectId) => `${subjectId}-${this.selectedTeacher[subjectId]}`
        );
        const subjectTeacherPairsString = subjectTeacherPairs.join('/');
        this.$router.push({ name: 'summary', params: { subjectTeacherPairs: subjectTeacherPairsString } });
      } else {
        this.$router.push({ name: 'PageNotFound' });
      }
    },
  },
};
</script>

<style lang="css" scoped>
</style>
